#!BPY
"""Registration info for Blender menus:
Name: 'L_system Serialsiner edition'
Blender: 232
Group: 'Misc'
Tip: 'Creation d arbres et vegetaux'
"""

######################################
#  L-System Script ver1.1
#
#  2001 Armagan YAVUZ
#  
#  Latest version can be obtained from:
#        www.geocities.com/blenderdungeon/
#
#  
######################################
#                                    #
# PRESS ALT+P TO ACTIVATE THE SCRIPT #
#                                    #
######################################
# Modify the line below to set a default directory 

defaultdir = "D:/Lsystem/"

import Blender
from lsystem import *
from rulesets import *
from stemRules import *
from leafRules import *
from Blender.Draw import *
from Blender.BGL import *


curversion = 110

num_params = 1
params = []
for i in range(num_params):
  params.append(Create(0.5))

stemparams = []
for i in range(num_params):
  stemparams.append(Create(0.5))


force = [Create(0.0), Create(0.0), Create(0.0)]
scaleforce = Create(0.0)
iteration= Create(2)
resolutionLOD= Create(0.75)
resolution= Create(16)
resolutionV= Create(2)
stemresolutionV= Create(2)
leafresolutionV= Create(1)
repeat= Create(1)
stemrepeat= Create(1)
leafrepeat= Create(1)
bangle = Create(90.0)
stembangle = Create(90.0)
leafbangle = Create(90.0)
menu= Create(5)
stemmenu= Create(1)
leafmenu= Create(1)
leafname= Create("a")
useleaf = Create(1)
leafscale = Create(1.0)
thickness = Create(0.1)
length = Create(0.5)
leaflength = Create(1.0)
rotF = Create(0.0)
stemrotF = Create(0.0)
leafrotF = Create(0.0)
curve = Create(0.0)
stemcurve = Create(0.0)
leafcurve = Create(0.0)
stemorientation = Create(0.0)
conism = Create(0.05)
shorten = Create(0.05)
branch_scale = Create(0.75)
stembranch_scale = Create(0.75)
lenscale = Create(0.75)
stemlenscale = Create(0.75)
prune = Create(0.0)
prunefirst = Create(0)
rot_rand_per = Create(0.1)
rot_rand_abs = Create(0.1)
leafbank = Create(0.0)
maxdepth = Create(30)
freeze=Create(0)
freeze2=Create(0)
seed=Create(0)


message = "Pret"

filename = Create(defaultdir)

def writeln(f,x):
  f.write(str(x))
  f.write("\n")

def readint(f):
  return int(f.readline())
def readfloat(f):
  return float(f.readline())
def readstr(f):
  s = (f.readline())
  return s[0:len(s)-1]

def do_file(save):
  fname = filename.val
  global message, iteration, params, stemparams, menu, stemmenu,leafmenu,thickness, length, leaflength, rotF, stemrotF, leafrotF,conism , branch_scale, stembranch_scale, lenscale, stemlenscale
  global prune, prunefirst, resolutionLOD, resolution, resolutionV, stemresolutionV, leafresolutionV, repeat, stemrepeat, leafrepeat, rot_rand_per,rot_rand_abs,leafname,useleaf,leafscale
  global force,scaleforce,bangle,stembangle,leafbangle
  global curve,stemcurve,leafcurve,stemorientation,leafbank,shorten,maxdepth

  if save:  message = "Fichier sauvegarde."
  else:     message = "Fichier charge."

  if save:
    try:
      f = open(fname,'w')
    except:
      message = "Sauvegarde impossible!"
      return
  else:
    try:
      f = open(fname,'r')
    except:
      message = "Fichier non trouve!"
      return

  if save:  writeln(f,curversion)
  else:
    version = readint(f)
    if version != curversion:
      message = "Mauvaise version de fichier!"
  if save:  writeln(f,iteration.val)
  else:     iteration.val = readint(f)

  if save:  writeln(f,params[0].val)
  else:     params[0].val = readfloat(f)
  if save:  writeln(f,stemorientation.val)
  else:     stemorientation.val = readfloat(f)

  if save:  writeln(f,menu.val)
  else:     menu.val = readint(f)
  if save:  writeln(f,stemmenu.val)
  else:     stemmenu.val = readint(f)
  if save:  writeln(f,leafmenu.val)
  else:     leafmenu.val = readint(f)

  if save:  writeln(f,thickness.val)
  else:     thickness.val = readfloat(f)

  if save:  writeln(f,length.val)
  else:     length.val = readfloat(f)
  if save:  writeln(f,leaflength.val)
  else:     leaflength.val = readfloat(f)

  if save:  writeln(f,rotF.val)
  else:     rotF.val = readfloat(f)
  if save:  writeln(f,stemrotF.val)
  else:     stemrotF.val = readfloat(f)
  if save:  writeln(f,leafrotF.val)
  else:     leafrotF.val = readfloat(f)

  if save:  writeln(f,conism.val)
  else:     conism.val = readfloat(f)

  if save:  writeln(f,branch_scale.val)
  else:     branch_scale.val = readfloat(f)
  if save:  writeln(f,stembranch_scale.val)
  else:     stembranch_scale.val = readfloat(f)
  if save:  writeln(f,lenscale.val)
  else:     lenscale.val = readfloat(f)
  if save:  writeln(f,stemlenscale.val)
  else:     stemlenscale.val = readfloat(f)

  if save:  writeln(f,prune.val)
  else:     prune.val = readfloat(f)
  if save:  writeln(f,prunefirst.val)
  else:     prunefirst.val = readint(f)

  if save:  writeln(f,resolutionLOD.val)
  else:     resolutionLOD.val = readfloat(f)
  if save:  writeln(f,resolution.val)
  else:     resolution.val = readint(f)
  if save:  writeln(f,resolutionV.val)
  else:     resolutionV.val = readint(f)
  if save:  writeln(f,stemresolutionV.val)
  else:     stemresolutionV.val = readint(f)
  if save:  writeln(f,repeat.val)
  else:     repeat.val = readint(f)
  if save:  writeln(f,stemrepeat.val)
  else:     stemrepeat.val = readint(f)
  if save:  writeln(f,leafrepeat.val)
  else:     leafrepeat.val = readint(f)

  if save:  writeln(f,rot_rand_per.val)
  else:     rot_rand_per.val = readfloat(f)
  if save:  writeln(f,rot_rand_abs.val)
  else:     rot_rand_abs.val = readfloat(f)

  if save:  writeln(f,leafname.val)
  else:     leafname.val = readstr(f)
  if save:  writeln(f,useleaf.val)
  else:     useleaf.val = readint(f)
  if save:  writeln(f,leafscale.val)
  else:     leafscale.val = readfloat(f)

  if save:  writeln(f,force[0].val)
  else:     force[0].val = readfloat(f)
  if save:  writeln(f,force[1].val)
  else:     force[1].val = readfloat(f)
  if save:  writeln(f,force[2].val)
  else:     force[2].val = readfloat(f)
  if save:  writeln(f,scaleforce.val)
  else:     scaleforce.val = readfloat(f)

  if save:  writeln(f,bangle.val)
  else:     bangle.val = readfloat(f)
  if save:  writeln(f,stembangle.val)
  else:     stembangle.val = readfloat(f)
  if save:  writeln(f,leafbangle.val)
  else:     leafbangle.val = readfloat(f)

  if save:  writeln(f,curve.val)
  else:     curve.val = readfloat(f)
  if save:  writeln(f,stemcurve.val)
  else:     stemcurve.val = readfloat(f)
  if save:  writeln(f,leafcurve.val)
  else:     leafcurve.val = readfloat(f)

  if save:  writeln(f,leafbank.val)
  else:     leafbank.val = readfloat(f)
  if save:  writeln(f,shorten.val)
  else:     shorten.val = readfloat(f)

  if save:  writeln(f,maxdepth.val)
  else:     maxdepth.val = readint(f)

  f.close()



def draw():
	global message, iteration, params, stemorientation,stemparams, menu, stemmenu,leafmenu,thickness, length, leaflength, rotF, stemrotF, leafrotF,conism , branch_scale, stembranch_scale, lenscale, stemlenscale, prune, prunefirst, resolutionLOD, resolution, resolutionV, stemresolutionV, leafresolutionV, repeat, stemrepeat, leafrepeat, rot_rand_per,rot_rand_abs,leafname,useleaf,leafscale,force,scaleforce,bangle,stembangle,leafbangle
	global curve,stemcurve,leafcurve,leafbank,shorten,maxdepth,freeze,freeze2,seed

	global filename

	glClearColor(0.6, 0.6, 0.65, 0.0)
	glClear(GL_COLOR_BUFFER_BIT)

	glColor3f(0.5,0.95,0.5)
	glRasterPos2i(10, 520)
	Text("L-System Script Serialsiner Edition 2004   ---   www.geocities.com/blenderdungeon/")

	filename = String("Nom du Fichier: ",2, 115, 485, 281, 19, filename.val, 50)
	Button("OUVRIR", 14, 10, 485, 101, 19)
	Button("ENREGISTRER", 15, 400, 485, 101, 19)



	glColor3f(0.2,0.2,0.0)
	glRasterPos2i(259, 465)
	Text("Ramifications:")
	menu= Menu("Ruleset%t| Droit %x1| Arm1 2D%x10| Arm1 3D%x11| Arm1+1 2D%x4| Arm1+1 3D%x12| Split2 2D%x2| Split2 3D%x3| Arm2 2D%x5| Arm2 3D%x6| 6Arm2+2 %x7| Split3%x8| Arm3%x9", 2, 340, 460, 111, 18, menu.val)

	params[0]= Slider("Orientation/branche ", 2, 259, 360, 244, 18, params[0].val, 0.0, 1.0)
	bangle = Slider("Angle/branche ", 2, 259, 380, 244, 18, bangle.val, 0.0, 180.0)
	lenscale = Slider("Longueur ", 2, 259, 340, 244, 18, lenscale.val, 0.5, 1.0)
	branch_scale = Slider("Diametre ", 2, 259, 320, 244, 18, branch_scale.val, 0.5, 1.0)
	rotF= Slider("Torsion ", 2, 259, 420, 244, 18, rotF.val, -360.0, 360.0)
	curve= Slider("Courbure ", 2, 259, 400, 244, 18, curve.val, -360.0, 360.0)
	resolutionV= Slider("Nb de segments ", 2, 259, 440, 244, 19, resolutionV.val, 1.0, 16.0)
	repeat= Number("X ", 2, 453, 460, 50, 18, repeat.val, 1, 10)

	glColor3f(0.2,0.1,0.0)
	glRasterPos2i(10, 465)
	Text("Branches:")
	stemmenu= Menu("Ruleset%t| Desactive %x1| Droit%x2| Arm1%x3| Arm1+1%x4| Arm2%x5| Arm2+2%x6| Arm3%x7", 2, 90, 460, 111, 18, stemmenu.val)

	stemorientation= Slider("Orientation/tronc ", 2, 10, 360, 244, 18, stemorientation.val, -180.0, 180.0)
	stembangle = Slider("Angle/tronc ", 2, 10, 380, 244, 18, stembangle.val, 0.0, 180.0)
	stemlenscale = Slider("Longueur ", 2, 10, 340, 244, 18, stemlenscale.val, 0.2, 2.0)
	stembranch_scale = Slider("Diametre ", 2, 10, 320, 244, 18, stembranch_scale.val, 0.5, 1.0)
	stemrotF= Slider("Torsion ", 2, 10, 420, 244, 18, stemrotF.val, -360.0, 360.0)
	stemcurve= Slider("Courbure ", 2, 10, 400, 244, 18, stemcurve.val, -360.0, 360.0)
	stemresolutionV= Slider("Nb de segments ", 2, 10, 440, 244, 19, stemresolutionV.val, 1.0, 16.0)
	stemrepeat= Number("X ", 2, 204, 460, 50, 18, stemrepeat.val, 1, 30)


	glColor3f(0.0,0.2,0.0)
	glRasterPos2i(259, 295)
	Text("Feuilles:")
	leafmenu= Menu("Ruleset%t| EndPoint%x1|Active Point%x7| 1+1 Parallel%x2| 1+1 Perpend.%x3| 2 Parallel%x4| 2 Perpend.%x5| 2+2 Perpend.%x66| 3 Perpend.%x8", 2, 340, 291, 111, 18, leafmenu.val)
	leafrepeat= Number("X ", 2, 453, 291, 50, 18, leafrepeat.val, 1, 30)
	leafbangle = Slider("Incliner feuilles ", 2, 259, 190, 244, 18, leafbangle.val, 0.0, 180.0)
	leafrotF= Slider("Vriller rameau ", 2, 259, 230, 244, 18, leafrotF.val, -90.0, 90.0)
	leafcurve= Slider("Courber rameau ", 2, 259, 210, 244, 18, leafcurve.val, -90.0, 90.0)
	leafresolutionV= Slider("Nb de segments ", 2, 259, 270, 244, 19, leafresolutionV.val, 1.0, 16.0)
	leafbank = Slider("Orienter feuilles ", 2, 259, 170, 244, 18, leafbank.val, 0.0, 90.0)
	leaflength= Slider("Allonger rameau ", 2, 259, 250, 244, 18, leaflength.val, 0.2, 5.0)

	useleaf = Toggle("Ajouter des Feuilles ",2, 259, 149, 122, 19, useleaf.val)
	leafname = String("Objet feuille: ",2, 385, 149, 118, 19, leafname.val, 12)
	leafscale= Slider("Taille des feuilles ", 2, 259, 129, 244, 18, leafscale.val, 0.2, 5.0)


	length= Slider("Taille totale ", 2, 10, 95, 244, 18, length.val, 0.0, 1.0)
	thickness= Slider("Circonference  ", 2, 10, 75, 244, 18, thickness.val, 0.0, 0.5)
	shorten = Slider("Raccourcir ", 2, 10, 55, 244, 18, shorten.val, 0.0, 0.2)
	conism= Slider("Affiner ", 2, 10, 35, 244, 18, conism.val, 0.0, 0.2)

	glColor3f(0.0,0.0,0.2)
	glRasterPos2i(10, 295)
	Text("Force:")
	scaleforce= Slider("Selon diametre ", 2, 60, 290, 194, 18, scaleforce.val, 0.0, 1.0)
	force[0]= Slider("Poids  ", 2, 10, 270, 244, 18, force[0].val, 0.0, 360.0)
	force[1]= Slider("Hauteur ", 2, 10, 250, 244, 18, force[1].val, -90.0, 90.0)
	force[2]= Slider("Magnitude ", 2, 10, 230, 244, 18, force[2].val, 0.0, 1.0)

	glColor3f(0.2,0.0,0.2)
	glRasterPos2i(10, 195)
	Text("Elagage:")
	prune = Slider("Probabilite ", 2, 10, 170, 244, 18, prune.val, 0.0, 0.5)
	prunefirst =  Number("Premiere taille: ", 2, 131, 190, 123, 19, prunefirst.val, 0, 29)
	maxdepth =  Number("Niveau max: ", 2, 10, 149, 130, 19, maxdepth.val, 0, 30)

	glColor3f(0.2,0.2,0.2)
	glRasterPos2i(10, 120)
	Text("General:")
	rot_rand_per = Slider("Redirection aleatoire ", 2, 259, 95, 244, 18, rot_rand_per.val, 0.0, 1.0)
	rot_rand_abs = Slider("Torsion aleatoire ", 2, 259, 75, 244, 18, rot_rand_abs.val, 0.0, 1.0)


	glColor3f(0.9,0.95,1.0)
	glRasterPos2i(259, 10)
	Text(message)

	Button("QUITTER", 1, 400, 5, 101, 19)
	Button("GENERER", 3, 10, 5, 101, 19)
	iteration= Number("iterations: ", 2, 142, 5, 112, 19, iteration.val, 1, 30)
	freeze= Toggle("geler : ", 2, 142, 149, 55, 19, freeze.val)
	freeze2= Toggle("geler2 : ", 2, 199, 149, 55, 19, freeze2.val)
	seed= Number("Seed: ", 2, 142, 129, 112, 18, seed.val,0,600)

	resolutionLOD = Slider("Niveau de detail ", 2, 259, 55, 244, 18, resolutionLOD.val, 0.0, 1.0)
	resolution= Number("resolution U: ", 2, 259, 34, 150, 18, resolution.val, 3, 32)





def event(evt, val):	
	if (evt== QKEY and not val): Exit()

def bevent(evt):
	global message
	if   (evt== 1): Exit()
	elif (evt== 2): Draw()
	elif (evt== 14): 
			do_file(0)
			Draw()
	elif (evt== 15): 
			do_file(1)
			Draw()
	elif (evt== 3): 
		message = "Generation en cours..."
		Draw()
		leafobj = None
		if (useleaf.val == 1) and (leafname.val != ""):
			leafobj = Blender.Object.Get(leafname.val)
			if leafobj == None:
				message = "Leaf obj. not found"
				Draw()
				return
		deg2rad =  3.1416 / 180.0
		bang = bangle.val * deg2rad
		nrotF = rotF.val * deg2rad / resolutionV.val
		ncurve = curve.val * deg2rad / resolutionV.val
		if menu.val == 1:
			rules = b_straight(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 2:
			rules = b_split2_2d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 3:
			rules = b_split2_3d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 4:
			rules = b_fork1_alt_2d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 5:
			rules = b_fork2_2d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 6:
			rules = b_fork2_3d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 7:
			rules = b_fork2_alt(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 8:
			rules = b_split3(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 9:
			rules = b_fork3(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 10:
			rules = b_fork1_2d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 11:
			rules = b_fork1_3d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 12:
			rules = b_fork1_alt_3d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)

		stemrules = None
		stembang = stembangle.val * 3.1416 / 180.0
		nrotF = stemrotF.val * deg2rad / stemresolutionV.val
		ncurve = stemcurve.val * deg2rad / stemresolutionV.val
		if stemmenu.val == 1:
			pass
		elif stemmenu.val == 2:
			stemrules = s_straight(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		elif stemmenu.val == 3:
			stemrules = s_fork1(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		elif stemmenu.val == 4:
			stemrules = s_fork1_alt(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		elif stemmenu.val == 5:
			stemrules = s_fork2(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		elif stemmenu.val == 6:
			stemrules = s_fork2_alt(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		elif stemmenu.val == 7:
			stemrules = s_fork3(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		if stemrules:
			rules[0] = stemrules[0] # copy axiom from stem
			rules[1].extend(stemrules[1])
			rules[2].extend(stemrules[2])

		leafrules = None
		leafbang = leafbangle.val * 3.1416 / 180.0
		leaf_len = leaflength.val * length.val
		nrotF = (leafrotF.val + rotF.val / leafrepeat.val)* deg2rad 
		ncurve = (leafcurve.val + curve.val / leafrepeat.val)* deg2rad 
		if leafmenu.val == 1:
			leafrules = l_endpoint(resolutionV.val,deg2rad * rotF.val / resolutionV.val,deg2rad * curve.val / resolutionV.val,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 7:
			leafrules = l_activepoint(resolutionV.val,deg2rad * rotF.val / resolutionV.val,deg2rad * curve.val / resolutionV.val,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 2:
			leafrules = l_fork1_alt_prl(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 3:
			leafrules = l_fork1_alt_prp(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 4:
			leafrules = l_fork2_prl(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 5:
			leafrules = l_fork2_prp(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 6:
			leafrules = l_fork2_alt_prp(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 8:
			leafrules = l_fork3_prp(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		if leafrules:
			rules[1].extend(leafrules[1])
			rules[2].extend(leafrules[2])

		torad = 3.1415926 / 180.0 
		maxd = 30
		if maxdepth.val > 0:
			maxd = maxdepth.val
		cart_force = [cos(force[0].val * torad) * cos(force[1].val * torad) * force[2].val, sin(force[0].val * torad) * cos(force[1].val * torad) * force[2].val, sin(force[1].val * torad) * force[2].val]

		lsystem_build(rules[0],rules[1],rules[2],
				iteration.val,length.val*thickness.val,conism.val,shorten.val,
					resolution.val,resolutionLOD.val,rot_rand_per.val * 4.0,rot_rand_abs.val * 2.0,prune.val,
					 prunefirst.val, maxd, cart_force, scaleforce.val,leafscale.val,leafobj,freeze.val,freeze2.val,seed.val)

		message = "Pret" 
Register(draw, event, bevent)


